/*
 *  Configuration information
 */



#include	"../h/param.h"
#include	"../h/types.h"
#include	"../h/sysmacros.h"
#include	"../h/conf.h"
#include	"../h/iobuf.h"
#include	"../h/tty.h"

extern nodev(), nulldev(), novec();


int	clock();
int	cnintr();
int	siointr();
int	siointr();
int	paintr();
int	flintr();
int	paintr();
int	siointr();
int	siointr();
int	fpuintr();
int	wdintr();


uchar_t 	vecintflags[] =
{
	SWITCH_INTR|CLOCK_INTR,
	SWITCH_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	SWITCH_INTR,
	SWITCH_INTR,
	SWITCH_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	SWITCH_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
	FAST_INTR,
};



uchar_t 	vecintlev[] =
{
	6,
	1,
	0,
	7,
	7,
	2,
	5,
	2,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	7,
	7,
	1,
	5,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
};



int 	(*vecintsw[])() =
{
	clock,
	cnintr,
	novec,
	siointr,
	siointr,
	paintr,
	flintr,
	paintr,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	siointr,
	siointr,
	fpuintr,
	wdintr,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
	novec,
};

extern fpuinit();
extern struct iobuf fltab;
extern flopen(), flclose(), flinit(), flhalt(), flread(), flwrite(), flioctl(), flstrategy();
extern struct iobuf wdtab;
extern wdopen(), wdhalt(), wdread(), wdwrite(), wdioctl(), wdstrategy();
extern struct tty sio_tty[];
extern sioopen(), sioclose(), sioinit(), siopoll(), sioread(), siowrite(), sioioctl();
extern paopen(), paclose(), painit(), pawrite(), paioctl();
extern mmread(), mmwrite();
extern cdbread(), cdbwrite();
extern rtcread(), rtcwrite();
extern erropen(), errclose(), errinit(), errread(), errioctl();
extern sxtopen(), sxtclose(), sxtread(), sxtwrite(), sxtioctl();
extern struct iobuf ramtab;
extern ramopen(), ramclose(), ramstrategy();
extern struct tty cn_tty[];
extern cnopen(), cnclose(), cninit(), cnread(), cnwrite(), cnioctl();
extern syopen(), syclose(), syread(), sywrite(), syioctl();

int	(*dinitsw[])()=
{
	fpuinit,
	flinit,
	sioinit,
	painit,
	errinit,
	cninit,
	(int (*)())0
};

int	(*dhaltsw[])()=
{
	flhalt,
	wdhalt,
	(int (*)())0
};

int	(*dpollsw[])()=
{
	siopoll,
	(int (*)())0
};

struct	bdevsw bdevsw[]=
{
/* 0*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 1*/ "hd"    , wdopen  , nulldev  , wdstrategy  , &wdtab  ,
/* 2*/ "fd"    , flopen  , flclose  , flstrategy  , &fltab  ,
/* 3*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 4*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 5*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 6*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 7*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 8*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/* 9*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*10*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*11*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*12*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*13*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*14*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*15*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*16*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*17*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*18*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*19*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*20*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*21*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*22*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*23*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*24*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*25*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*26*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*27*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*28*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*29*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*30*/ 0       , nodev   , nodev    , nodev       ,  0      ,
/*31*/ "ram"   , ramopen , ramclose , ramstrategy , &ramtab ,
};

struct	cdevsw cdevsw[]=
{
/* 0*/ "scrn"  , cnopen  , cnclose  , cnread  , cnwrite  , cnioctl  , cn_tty,0,
/* 1*/ "hd"    , wdopen  , nulldev  , wdread  , wdwrite  , wdioctl  , 0,0,
/* 2*/ "fd"    , flopen  , flclose  , flread  , flwrite  , flioctl  , 0,0,
/* 3*/ "tty"   , syopen  , syclose  , syread  , sywrite  , syioctl  , 0,0,
/* 4*/ "memory" , nulldev , nulldev  , mmread  , mmwrite  , nodev    , 0,0,
/* 5*/ "sio"   , sioopen , sioclose , sioread , siowrite , sioioctl , sio_tty,0,
/* 6*/ "pa"    , paopen  , paclose  , nodev   , pawrite  , paioctl  , 0,0,
/* 7*/ "cdb"   , nulldev , nulldev  , cdbread , cdbwrite , nodev    , 0,0,
/* 8*/ "rtc"   , nulldev , nulldev  , rtcread , rtcwrite , nodev    , 0,0,
/* 9*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*10*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*11*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*12*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*13*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*14*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*15*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*16*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*17*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*18*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*19*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*20*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*21*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*22*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*23*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*24*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*25*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*26*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*27*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*28*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*29*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*30*/ "sxt"   , sxtopen , sxtclose , sxtread , sxtwrite , sxtioctl , 0,0,
/*31*/ 0       , nodev   , nodev    , nodev   , nodev    , nodev    , 0      ,
0         ,
/*32*/ "err"   , erropen , errclose , errread , nodev    , errioctl , 0,0,
};

int	bdevcnt=	32;
int	cdevcnt=	33;

int	bdevmax=	32;
int	cdevmax=	33;

dev_t	rootdev=	makedev(1,40);
dev_t	pipedev=	makedev(1,40);
dev_t	swapdev=	makedev(1,41);
daddr_t	swplo=	0;
int	nswap=	0;


int	ttopen(), ttclose(), ttread(), ttwrite(), ttioctl(), ttin(), ttout();


int	sxtrwrite(), sxtin(), sxtout();

struct linesw linesw[]=
{
/*0*/ ttopen, ttclose, ttread, ttwrite, ttioctl, ttin, ttout, nulldev,
/*1*/ nulldev, nulldev, nulldev, sxtrwrite, nulldev, sxtin, sxtout, nulldev,
        0
};

int	linecnt = 2;

