;
;	%Z% %M% %I% %D% %Q%
;
;	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
;	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
;	This Module contains Proprietary Information of
;	The Santa Cruz Operation, Microsoft Corporation
;	and AT&T, and should be treated as Confidential.
;

	TITLE   space


	.386

include sizeof.inc
include space.inc

DGROUP	GROUP	_BSS, _DATA

PUBLIC	_file
PUBLIC	_proc
PUBLIC	_cfree
PUBLIC	_callout

PUBLIC	_msgent
PUBLIC	_msgque
PUBLIC	_msgh

PUBLIC	_sem
PUBLIC	_sema
PUBLIC	_sement
PUBLIC	_sem_undo
PUBLIC	_semu
PUBLIC	_semtmp

PUBLIC	_shmid_tab
PUBLIC	_shmid_pos
PUBLIC	_sdtab

PUBLIC	_emap
PUBLIC	_sxtlink
PUBLIC	_mount
PUBLIC	_locklist
PUBLIC	_pfreelist
PUBLIC	_pbuf
PUBLIC	_hbuf
PUBLIC	_coreent
PUBLIC	_text
PUBLIC	_pgstat
PUBLIC	_inode
PUBLIC  _nfs1
PUBLIC  _nfs2

EXTRN	_binit:NEAR
EXTRN	_iinit:NEAR
EXTRN	_dfinit:NEAR
EXTRN	_clkinit:NEAR
EXTRN	_meminit:NEAR
EXTRN	_cinit:NEAR

_DATA	SEGMENT  DWORD USE32 PUBLIC 'DATA'

	ALIGN 4
	PUBLIC  _init_tbl
_init_tbl	DD	_clkinit
	DD	_cinit
	DD	_binit
	DD	_iinit
	DD	_meminit
	DD	_dfinit
	DD	00H
	PUBLIC  _Timezone
_Timezone	DD	TIMEZONE
	PUBLIC  _Dstflag
_Dstflag	DD	DSTFLAG
	PUBLIC  _Cmask
_Cmask	DD	CMASK

	PUBLIC  _coremap
_coremap	DD	00H
	DD	CMAPSIZ
	DD	_coreent

	PUBLIC	_sptent
	PUBLIC  _sptmap
_sptmap	DD	00H
	DD	064H
	DD	_sptent

	PUBLIC  _Hz
_Hz	DD	HZ

	PUBLIC  _dma_single
_dma_single	DD	DMAEXCL
	
	PUBLIC	_memlim
_memlim		DD	MEMLIM

	PUBLIC	_swplim
_swplim		DD	SWPLIM

	PUBLIC	_node
_node	db	NODE, 00H
	db	(8)dup(0)
	ALIGN 4

	PUBLIC  _msgmap
_msgmap	DD	00H
	DD	MSGMAP
	DD	_msgent
	PUBLIC  _msginfo

_msginfo	DD	MSGMAP
	DD	MSGMAX
	DD	MSGMNB
	DD	MSGMNI
	DD	MSGSSZ
	DD	MSGTQL
	DW	MSGSEG
	
	ALIGN 4

	PUBLIC  _semmap
_semmap	DD	00H
	DD	SEMMAP
	DD	_sement
	PUBLIC  _seminfo
_seminfo	DD	SEMMAP
	DD	SEMMNI
	DD	SEMMNS
	DD	SEMMNU
	DD	SEMMSL
	DD	SEMOPM
	DD	SEMUME
	DD	(SEMUME * SZ_UNDO) + SZ_SEMUNDO
	DD	SEMVMX
	DD	SEMAEM

	PUBLIC  _shminfo386
_shminfo386	DD	SHMMAX
	DD	SHMMIN
	DD	SHMMNI
	DD	SHMSEG
	DD	SHMBRK
	DD	SHMALL

	PUBLIC  _shminfo286
_shminfo286	DD	010000H
	DD	01H
	DD	SHMMNI
	DD	SHMSEG
	DD	SHMBRK
	DD	SHMALL

	PUBLIC  _v
_v	DD	NBUF
	DD	NSABUF
	DD	NHBUF
	DD	NHBUF-1
	DD	MAXBUF
	DD	NCALL
	DD	NINODE
	DD	SZ_INODE * NINODE + _inode
	DD	NFILE
	DD	SZ_FILE * NFILE + _file
	DD	NMOUNT
	DD	SZ_MOUNT * NMOUNT + _mount
	DD	NPROC
	DD	SZ_PROC * NPROC + _proc
	DD	NTEXT
	DD	SZ_TEXT * NTEXT + _text
	DD	NCLIST
	DD	MAXUPRC
	DD	MAXMEM
	DD	NFLOCKS
	DD	NSDSEGS
	DD	NSDSLOTS
	DD	MSGMAP
	DD	MSGMAX
	DD	MSGMNB
	DD	MSGMNI
	DD	MSGTQL
	DD	MSGSSZ
	DW	MSGSEG
	ALIGN 4
	DD	SEMMAP
	DD	SEMMNI
	DD	SEMMNU
	DD	SEMMSL
	DD	SEMOPM
	DD	SEMUME
	DD	SEMVMX
	DD	SEMAEM
	DD	SEMMNS
	DD	(SEMUME * SZ_UNDO) + SZ_SEMUNDO
	DD	NSCRN
	DD	NPBUF
	DD	NEMAP
	DD	NSXT
	DD	SHMMAX
	DD	SHMMIN
	DD	SHMMNI
	DD	SHMSEG
	DD	SHMBRK
	DD	SHMALL
	DD	(NSDSEGS * NSDSLOTS)

_DATA      ENDS

_BSS	SEGMENT  DWORD USE32 PUBLIC 'BSS'

_nfs1		dd	1 dup(?)
_nfs2		dd	1 dup(?)
_shmid_pos	dd	1 dup(?)


	ALIGN 4
_pfreelist	db	(SZ_PFREE)dup(?)
	ALIGN 4
_pbuf		db	(NPBUF * SZ_BUF)dup(?)
	ALIGN 4
_pgstat		db	(SZ_PGSTAT)dup(?)

	ALIGN 4
_hbuf		db	(NHBUF * SZ_HBUF)dup(?)
	ALIGN 4
_file		db	(NFILE * SZ_FILE)dup(?)
	ALIGN 4
_inode		db	(NINODE * SZ_INODE)dup(?)
	ALIGN 4
_locklist	db	(NFLOCKS * SZ_LOCKL)dup(?)

	ALIGN 4
_sdtab		db	(NSDSEGS * NSDSLOTS * SZ_SD)dup(?)
	ALIGN 4
_shmid_tab	db	(NSDSEGS * SZ_SHMID)dup(?)

	ALIGN 4
_proc		db	(NPROC * SZ_PROC)dup(?)
	ALIGN 4
_text		db	(NTEXT * SZ_TEXT)dup(?)
	ALIGN 4
_coreent	db	(CMAPSIZ * SZ_MAPENT)dup(?)
	ALIGN 4
_sptent		db	(064H * SZ_MAPENT)dup(?)

	ALIGN 4
_callout	db	(NCALL * SZ_CALLO)dup(?)
	ALIGN 4
_cfree		db	(NCLIST * SZ_CBLOCK)dup(?)
	ALIGN 4
_mount		db	(NMOUNT * SZ_MOUNT)dup(?)
	ALIGN 4
_emap		db	(NEMAP * SZ_EMAP)dup(?)
	ALIGN 4
_sxtlink	db	(NSXT * SZ_SXT)dup(?)

	ALIGN 4
_msgent		db	(MSGMAP * SZ_MAPENT)dup(?)
	ALIGN 4
_msgque		db	(MSGMNI * SZ_MSQID)dup(?)
	ALIGN 4
_msgh		db	(MSGTQL * SZ_MSG)dup(?)

	ALIGN 4
_sema		db	(SEMMNI * SZ_SEMID)dup(?)
	ALIGN 4
_sem		db	(SEMMNS * SZ_SEM)dup(?)
	ALIGN 4
_sement		db	(SEMMAP * SZ_MAPENT)dup(?)
	ALIGN 4
_sem_undo	db	(NPROC * SZ_STRUCTPTR)dup(?)
	ALIGN 4
_semu	dd (((((SZ_UNDO * SEMUME) + SZ_SEMUNDO) * SEMMNU) + NBPW - 1 ) / NBPW)dup(?)
	ALIGN 4
if ((SEMMSL * SZ_USHORT) GT SZ_SEMID) AND ((SEMMSL * SZ_USHORT) GT (SEMOPM * SZ_SEMBUF))
_semtmp db (SEMMSL * SZ_USHORT)dup(?)
else
if (SZ_SEMID GT (SEMOPM * SZ_SEMBUF)) AND (SZ_SEMID GT (SEMMSL * SZ_USHORT))
_semtmp db (SZ_SEMID)dup(?)
else
_semtmp db (SEMOPM * SZ_SEMBUF)dup(?)
endif
endif

_BSS      ENDS

END
